import javax.swing.*;
import java.util.*;
import java.io.*;
import java.lang.reflect.*;

public class TestReflection {
   public Class dieKlasse;
   public Class oberKlasse;
   

   public static void main(String[] args) {
      String s ;
      TestReflection test = new TestReflection() ;
      
//      JButton b = new JButton("ja");
//      test.druckeKlassenName(b);
      Blase bl = new Blase();
//      test.druckeKlassenName(bl);

//      test.erzeugeUndDruckeNamen("Blase");
      
//      test.druckeModifizierer(bl);
      
//      test.druckeSuperklassen(new JButton("ja"));

//      test.druckeInterfaceNamen(new Blase());

//      test.druckeFeldNamen(new SprechBlase());
      
//      test.zeigeKonstruktoren(new Blase()) ;
      
//      test.zeigeMethoden(new SprechBlase());
      
      Object obj = test.erzeugeObjekt("Blase") ;
      System.out.println(obj.toString());
//      obj.pumpen();


   }

   public void druckeKlassenName(Object obj) {
      dieKlasse = obj.getClass();
      System.out.println("Name der Klasse: " + dieKlasse.getName());
   }

   public void erzeugeUndDruckeNamen(String s) {
      try {
         dieKlasse = Class.forName(s);
         System.out.println("Name der Klasse: " + dieKlasse.getName());
      }
      catch(ClassNotFoundException cnfe) {
         System.out.println("Klasse nicht gefunden!");
      }
   }

   public void druckeModifizierer(Object obj) {
      dieKlasse = obj.getClass();
      int m = dieKlasse.getModifiers() ;
      System.out.println("Modifizierer: " + m);
      
      if (Modifier.isPublic(m)) {
         System.out.println("Modifizierer: public" );
      }

      if (Modifier.isPrivate(m)) {
         System.out.println("Modifizierer: private" );
      }
   }

   public void druckeSuperklassen(Object obj) {
      dieKlasse = obj.getClass();
      oberKlasse = dieKlasse.getSuperclass();
      
      while (oberKlasse != null) {
         String className = oberKlasse.getName();
         System.out.println(className);
         dieKlasse = oberKlasse;
         oberKlasse = dieKlasse.getSuperclass();
      }
   }
   
   public void druckeInterfaceNamen(Object obj) {
      dieKlasse = obj.getClass();
      Class[] dieInterfaces = dieKlasse.getInterfaces();
      
      if (dieInterfaces.length == 0) System.out.println("Keine Interfaces gefunden");

      for (int i = 0; i < dieInterfaces.length; ++i) {
         String interfaceName = dieInterfaces[i].getName();
         System.out.println(interfaceName);
      }
   }

   public void druckeFeldNamen(Object obj) {
      dieKlasse = obj.getClass();
      Field[] publicFields = dieKlasse.getFields();

      if (publicFields.length == 0) System.out.println("Keine Fields gefunden");

      for (int i = 0; i < publicFields.length; ++i) {
         String fieldName = publicFields[i].getName();
         Class typeClass = publicFields[i].getType();
         String fieldType = typeClass.getName();
         System.out.println("Name: " + fieldName + ", Type: " + fieldType);
      }
   }
   
   public void zeigeKonstruktoren(Object obj) {
      dieKlasse = obj.getClass();
      Constructor[] dieKonstruktoren = dieKlasse.getConstructors();

      if (dieKonstruktoren.length == 0) System.out.println("Keine Konstruktoren gefunden");

      for (int i = 0; i < dieKonstruktoren.length; ++i) {
         System.out.print("( ");
         Class[] parameterTypen = dieKonstruktoren[i].getParameterTypes();

         for (int k = 0; k < parameterTypen.length; ++k) {
            String parameterString = parameterTypen[k].getName();
            System.out.print(parameterString + " ");
         }
         System.out.println(")");
      }
   }

   public void zeigeMethoden(Object obj) {
      dieKlasse = obj.getClass();
      Method[] dieMethoden = dieKlasse.getMethods();

      if (dieMethoden.length == 0) System.out.println("Keine Methoden gefunden");

      for (int i = 0; i < dieMethoden.length; ++i) {
         String methodenName = dieMethoden[i].getName();
         System.out.println("Name: " + methodenName);
         String returnTyp = dieMethoden[i].getReturnType().getName();
         System.out.println("   Return Type: " + returnTyp);
         Class[] parameterTypes = dieMethoden[i].getParameterTypes();
         System.out.print("   Parameter Types:");

         for (int k = 0; k < parameterTypes.length; ++k) {
            String parameterString = parameterTypes[k].getName();
            System.out.print(" " + parameterString);
         }
         System.out.println();
      }
   }
   
   public Object erzeugeObjekt(String classenName) {
      Object obj = null;

      try {
          Class classenDeskriptor = Class.forName(classenName);
          obj = classenDeskriptor.newInstance();
      }
      catch (ClassNotFoundException e) {
          System.out.println(e);
      }
      catch (InstantiationException e) {
          System.out.println(e);
      }
      catch (IllegalAccessException e) {
          System.out.println(e);
      }

      return obj;
   }

}


